global gBtnList, gCastLoopDone, gTrailerLoopDone, gCurrentFrame, gFlashState, gAnimalLoopDone, gProLoopDone

on startMovie
  set gCastLoopDone to 0
  set gAnimalLoopDone to 0
  set gProLoopDone to 0
  set gTrailerLoopDone to 0
  set gFlashState to 1
  register(xtra("PrintOMatic"), "POMX153-067-03058")
end

on stopMovie
end

on init start, stop, TF, whichcursor
  repeat with whichSprite = start to stop
    puppetSprite(whichSprite, TF)
    set the cursor of sprite whichSprite to whichcursor
  end repeat
end

on wait ticks
  set startDelay to the timer
  repeat while the timer < (startDelay + ticks)
  end repeat
end

on initBtns
  set start to 1
  set stop to 48
  set gBtnList to []
  repeat with s = start to stop
    if the memberNum of sprite s <> 0 then
      if word 1 of the name of member the memberNum of sprite s = "btn" then
        add(gBtnList, new(script "btnParentScript", s))
        puppetSprite(s, 1)
        set the cursor of sprite s to [the number of member "pushCursor", the number of member "pushMask"]
        next repeat
      end if
      if word 1 of the name of member the memberNum of sprite s = "radio" then
        add(gBtnList, new(script "RadioBtnParentScript", s))
        puppetSprite(s, 1)
        set the cursor of sprite s to [the number of member "pushCursor", the number of member "pushMask"]
        next repeat
      end if
      if word 1 of the name of member the memberNum of sprite s = "scroll" then
        add(gBtnList, new(script "ScrollBtnParentScript", s))
        puppetSprite(s, 1)
        set the cursor of sprite s to [the number of member "pushCursor", the number of member "pushMask"]
        next repeat
      end if
      if word 1 of the name of member the memberNum of sprite s = "chk" then
        add(gBtnList, new(script "ChkBtnParentScript", s))
        puppetSprite(s, 1)
        set the cursor of sprite s to [the number of member "pushCursor", the number of member "pushMask"]
      end if
    end if
  end repeat
end

on doRoll
  repeat with whichbtn in gBtnList
    if (the memberNum of sprite the myS of whichbtn = the myUpState of whichbtn) or (the memberNum of sprite the myS of whichbtn = the myRollState of whichbtn) then
      doRoll(whichbtn)
    end if
  end repeat
end

on doRollAnim
  repeat with whichbtn in gBtnList
    if (the memberNum of sprite the myS of whichbtn = the myUpState of whichbtn) or (the memberNum of sprite the myS of whichbtn = the myRollState of whichbtn) then
      doRollAnim(whichbtn)
    end if
  end repeat
end

on getBtnObj s
  repeat with whichbtn in gBtnList
    if s = the myS of whichbtn then
      return whichbtn
    end if
  end repeat
  alert("Problem locating this button object. Check 'initbtns' handler. Is sprite " & s & " in the list?")
end

on goPlay
  set the movieRate of sprite 6 to 1
  set the loc of sprite 10 to the loc of sprite 9
  set the loc of sprite 9 to point(-500, -500)
  updateStage()
end

on goPause
  set the movieRate of sprite 6 to 0
  set the loc of sprite 9 to the loc of sprite 10
  set the loc of sprite 10 to point(-500, -500)
  updateStage()
end

on goRewind
  if the movieTime of sprite 6 <> 0 then
    set the movieTime of sprite 6 to 0
    set the movieRate of sprite 6 to 0
    set the loc of sprite 9 to point(320, 240)
    set the loc of sprite 10 to point(-500, -500)
    updateStage()
  end if
end

on activeLoop startMember, stopMember, s
  global gLoopCount
  if not (the puppet of sprite s) then
    puppetSprite(s, 1)
  end if
  if the name of member the memberNum of sprite s <> stopMember then
    set the memberNum of sprite s to the number of member startMember + gLoopCount
    set gLoopCount to gLoopCount + 1
    updateStage()
    return 0
  else
    return 1
  end if
end

on castLoop n, snd, ticks, start, end
  if not integerp(start) then
    set start to the number of member start
  end if
  if not integerp(end) then
    set end to the number of member end
  end if
  preLoadCast(start, end)
  set puppetState to the puppet of sprite n
  puppetSprite(n, 1)
  if snd <> 0 then
    puppetSound(snd)
  end if
  repeat with i = start to end
    set the castNum of sprite n to i
    updateStage()
    if ticks > 0 then
      wait(ticks)
    end if
  end repeat
  unLoadCast(start, end - 1)
  puppetSprite(n, puppetState)
end

on backLoop n, snd, ticks, start, end
  if not integerp(start) then
    set start to the number of member start
  end if
  if not integerp(end) then
    set end to the number of member end
  end if
  preLoadCast(start, end)
  set puppetState to the puppet of sprite n
  puppetSprite(n, 1)
  if snd <> 0 then
    puppetSound(snd)
  end if
  repeat with i = start down to end
    set the castNum of sprite n to i
    updateStage()
    if ticks > 0 then
      wait(ticks)
    end if
  end repeat
  unLoadCast(start, end)
  puppetSprite(n, puppetState)
end

on apeLoop n, snd, ticks, start, end
  preloadMember("apeThud", "wiff")
  if not integerp(start) then
    set start to the number of member start
  end if
  if not integerp(end) then
    set end to the number of member end
  end if
  preLoadCast(start, end)
  puppetSound(snd)
  updateStage()
  set puppetState to the puppet of sprite n
  set flag to 0
  puppetSprite(n, 1)
  set counter to 1
  repeat with i = start to end
    set the castNum of sprite n to i
    if (counter = 10) or (counter = 20) then
      puppetSound("apeThud")
    else
      if (counter > 25) and (counter < 36) and not flag then
        puppetSound("wiff")
        set flag to 1
      else
        if counter = 36 then
          puppetSound("woodKnock")
        end if
      end if
    end if
    updateStage()
    set counter to counter + 1
    if ticks > 0 then
      wait(ticks)
    end if
  end repeat
  unLoadCast(start, end - 1)
  puppetSprite(n, puppetState)
end

on goMovie movieNum
  init(1, 48, 0, 0)
  go(gCurrentFrame & movieNum)
end

on goClip clipNum
  init(1, 48, 0, 0)
  if clipNum = "making of" then
    if the memberNum of sprite 6 > 0 then
      if the type of member the memberNum of sprite 6 = #digitalVideo then
        if not (the puppet of sprite 6) then
          puppetSprite(6, 1)
        end if
        set the memberNum of sprite 6 to the number of member "matte left"
        set the loc of sprite 6 to point(320, 240)
        updateStage()
      end if
    end if
    init(1, 48, 0, 0)
    go("making of")
  else
    go(gCurrentFrame & clipNum)
  end if
end

on goPic picNum
  init(1, 48, 0, 0)
  if not (the puppet of sprite 32) then
    puppetSprite(32, 1)
  end if
  set the memberNum of sprite 32 to the number of member ("Print" & picNum)
  updateStage()
  go(the frame + 1)
end

on flasher
  repeat with s = 16 to 21
    if the name of member the memberNum of sprite s = "roll" then
      set g to 1
      exit repeat
      next repeat
    end if
    set g to 0
  end repeat
  if g = 0 then
    if not (the puppet of sprite 23) then
      puppetSprite(23, 1)
    end if
    set the memberNum of sprite 23 to the number of member ("flash" & random(5))
    updateStage()
    wait(20)
    set the memberNum of sprite 23 to the number of member "dot"
  end if
end

on goPrint
  set doc to new(xtra("PrintOMatic"))
  if not objectp(doc) then
    exit
  end if
  setLandscapeMode(doc, 1)
  newPage(doc)
  append(doc, sprite(32))
  if doJobSetup(doc) = 1 then
    print(doc)
  end if
  set doc to 0
end

on goPrintText
  set doc to new(xtra("PrintOMatic"))
  if not objectp(doc) then
    exit
  end if
  newPage(doc)
  append(doc, sprite(7))
  if doJobSetup(doc) = 1 then
    print(doc)
  end if
  set doc to 0
end

on goPreAnimals
  init(1, 48, 0, 0)
  go("preanimals")
end

on goAnimalsFrame
  global gAnimalLoopDone
  init(1, 48, 0, 0)
  if gAnimalLoopDone then
    go("AnimalAnimDone")
  else
    go("Animals")
  end if
end

on scriptBot
  set temp to the scriptText of member 572
  set s to 572
  repeat while s <= 633
    set s to s + 3
    set the scriptText of member s to temp
  end repeat
end

on nameBot
  set temp to the name of member 871
  set s to 871
  repeat while s <= 965
    set s to s + 3
    set the name of member s to temp
  end repeat
end
